// vim: et:ts=4:sw=4:sts=4:ft=javascript

'use strict';

/*@
Ox.CollapsePanel <f:Ox.Panel> CollapsePanel Object
    () ->              <f> CollapsePanel Object
    (options) ->       <f> CollapsePanel Object
    (options, self) -> <f> CollapsePanel Object
    options <o> Options object
        collapsed <b|false> collapsed state
        extras <a|[]> panel extras
        size <n|16> size
        title <s> title
    self    <o> shared private variable
@*/

Ox.CollapsePanel = function(options, self) {

    self = self || {};
    var that = Ox.Panel({}, self)
            .defaults({
                collapsed: false,
                extras: [],
                size: 16,
                title: ''
            })
            .options(options)
            .addClass('OxCollapsePanel');

    self.$titlebar = Ox.Bar({
            orientation: 'horizontal',
            size: self.options.size,
        })
        .bindEvent({
            doubleclick: doubleclickTitlebar
        })
        .appendTo(that);

    self.$button = Ox.Button({
            style: 'symbol',
            type: 'image',
            value: self.options.collapsed ? 'expand' : 'collapse',
            values: [
                {id: 'expand', title: 'right'},
                {id: 'collapse', title: 'down'}
            ]
        })
        .bindEvent({
            click: toggleCollapsed
        })
        .appendTo(self.$titlebar);

    self.$title = Ox.Element()
        .addClass('OxTitle')
        .html(self.options.title)
        .appendTo(self.$titlebar);

    if (self.options.extras.length) {
        self.$extras = Ox.Element()
            .addClass('OxExtras')
            .appendTo(self.$titlebar);
        self.options.extras.forEach(function($extra) {
            $extra.appendTo(self.$extras);
        });
    }

    that.$content = Ox.Element()
        .addClass('OxContent')
        .appendTo(that);
    // fixme: doesn't work, content still empty
    // need to hide it if collapsed
    if (self.options.collapsed) {
        that.$content.css({
            marginTop: -that.$content.height() + 'px'
        });
    }

    function doubleclickTitlebar(e) {
        if (!$(e.target).hasClass('OxButton')) {
            self.$button.trigger('click');
        }
    }

    function toggleCollapsed() {
        var marginTop;
        self.options.collapsed = !self.options.collapsed;
        marginTop = self.options.collapsed ? -that.$content.height() : 0;
        that.$content.animate({
            marginTop: marginTop + 'px'
        }, 200);
        that.triggerEvent('toggle', {
            collapsed: self.options.collapsed
        });
    }

    /*@
    setOption <f> setOption
        (key, value) -> <u> set key to value
    @*/
    self.setOption = function(key, value) {
        if (key == 'collapsed') {
            self.$button.trigger('click');
        } else if (key == 'title') {
            self.$title.html(self.options.title);
        }
    };

    /*@
    update <f> update // fixme: used anywhere?
    @*/
    that.update = function() {
        self.options.collapsed && that.$content.css({
            marginTop: -that.$content.height()
        });
    };

    return that;

};
